diff --git a/src/btree/bt_curnext.c b/src/btree/bt_curnext.c
index aba32df86..346a64d4a 100644
--- a/src/btree/bt_curnext.c
+++ b/src/btree/bt_curnext.c
@@ -422,6 +422,11 @@ __cursor_row_next(
      * Initialize for each new page.
      */
     if (newpage) {
+        __wt_yield();
+        __wt_yield();
+        __wt_yield();
+        __wt_yield();
+        __wt_yield();
         /*
          * Be paranoid and set the slot out of bounds when moving to a new page.
          */
diff --git a/src/btree/bt_curprev.c b/src/btree/bt_curprev.c
index 879cbd0e2..20cdf0036 100644
--- a/src/btree/bt_curprev.c
+++ b/src/btree/bt_curprev.c
@@ -597,6 +597,11 @@ __cursor_row_prev(
      * Initialize for each new page.
      */
     if (newpage) {
+        __wt_yield();
+        __wt_yield();
+        __wt_yield();
+        __wt_yield();
+        __wt_yield();
         /* Check if keys need to be instantiated before we walk the page. */
         WT_RET(__wt_row_leaf_key_instantiate(session, page));
 
diff --git a/test/format/ops.c b/test/format/ops.c
index 92f3d3cf1..135d1eae3 100644
--- a/test/format/ops.c
+++ b/test/format/ops.c
@@ -268,6 +268,7 @@ operations(u_int ops_seconds, u_int run_current, u_int run_total)
     WT_CONNECTION *conn;
     WT_SESSION *session;
     wt_thread_t alter_tid, backup_tid, checkpoint_tid, compact_tid, hs_tid, import_tid, random_tid;
+    wt_thread_t hs_tid_0, hs_tid_1, hs_tid_2, hs_tid_3, hs_tid_4, hs_tid_5, hs_tid_6, hs_tid_7, hs_tid_8, hs_tid_9;
     wt_thread_t timestamp_tid;
     int64_t fourths, quit_fourths, thread_ops;
     uint32_t i;
@@ -285,6 +286,16 @@ operations(u_int ops_seconds, u_int run_current, u_int run_total)
     memset(&checkpoint_tid, 0, sizeof(checkpoint_tid));
     memset(&compact_tid, 0, sizeof(compact_tid));
     memset(&hs_tid, 0, sizeof(hs_tid));
+    memset(&hs_tid_0, 0, sizeof(hs_tid_0));
+    memset(&hs_tid_1, 0, sizeof(hs_tid_1));
+    memset(&hs_tid_2, 0, sizeof(hs_tid_2));
+    memset(&hs_tid_3, 0, sizeof(hs_tid_3));
+    memset(&hs_tid_4, 0, sizeof(hs_tid_4));
+    memset(&hs_tid_5, 0, sizeof(hs_tid_5));
+    memset(&hs_tid_6, 0, sizeof(hs_tid_6));
+    memset(&hs_tid_7, 0, sizeof(hs_tid_7));
+    memset(&hs_tid_8, 0, sizeof(hs_tid_8));
+    memset(&hs_tid_9, 0, sizeof(hs_tid_9));
     memset(&import_tid, 0, sizeof(import_tid));
     memset(&random_tid, 0, sizeof(random_tid));
     memset(&timestamp_tid, 0, sizeof(timestamp_tid));
@@ -350,8 +361,19 @@ operations(u_int ops_seconds, u_int run_current, u_int run_total)
         testutil_check(__wt_thread_create(NULL, &backup_tid, backup, NULL));
     if (GV(OPS_COMPACTION))
         testutil_check(__wt_thread_create(NULL, &compact_tid, compact, NULL));
-    if (GV(OPS_HS_CURSOR))
+    if (GV(OPS_HS_CURSOR)){
         testutil_check(__wt_thread_create(NULL, &hs_tid, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_0, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_1, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_2, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_3, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_4, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_5, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_6, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_7, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_8, hs_cursor, NULL));
+        testutil_check(__wt_thread_create(NULL, &hs_tid_9, hs_cursor, NULL));
+    }
     if (GV(IMPORT))
         testutil_check(__wt_thread_create(NULL, &import_tid, import, NULL));
     if (GV(OPS_RANDOM_CURSOR))
@@ -449,8 +471,19 @@ operations(u_int ops_seconds, u_int run_current, u_int run_total)
         testutil_check(__wt_thread_join(NULL, &checkpoint_tid));
     if (GV(OPS_COMPACTION))
         testutil_check(__wt_thread_join(NULL, &compact_tid));
-    if (GV(OPS_HS_CURSOR))
+    if (GV(OPS_HS_CURSOR)){
         testutil_check(__wt_thread_join(NULL, &hs_tid));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_0));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_1));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_2));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_3));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_4));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_5));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_6));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_7));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_8));
+        testutil_check(__wt_thread_join(NULL, &hs_tid_9));
+    }
     if (GV(IMPORT))
         testutil_check(__wt_thread_join(NULL, &import_tid));
     if (GV(OPS_RANDOM_CURSOR))
diff --git a/test/format/verify.c b/test/format/verify.c
index 1c4c04352..2a957cb9d 100644
--- a/test/format/verify.c
+++ b/test/format/verify.c
@@ -159,6 +159,10 @@ table_verify_mirror(WT_CONNECTION *conn, TABLE *base, TABLE *table, const char *
     base_ret = table_ret = 0;
     last_match = 0;
 
+    if (true) {
+        return;
+    }
+
     memset(&sap, 0, sizeof(sap));
     wt_wrap_open_session(conn, &sap, NULL, &session);
 